﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using San9.Editor.Forms;

namespace San9.Editor {
  public partial class ParentForm : Form {
    public ParentForm() {
      InitializeComponent();
    }

    private void ExitToolsStripMenuItem_Click(object sender, EventArgs e) {
      this.Close();
    }

    private void CascadeToolStripMenuItem_Click(object sender, EventArgs e) {
      LayoutMdi(MdiLayout.Cascade);
    }

    private void TileVerticalToolStripMenuItem_Click(object sender, EventArgs e) {
      LayoutMdi(MdiLayout.TileVertical);
    }

    private void TileHorizontalToolStripMenuItem_Click(object sender, EventArgs e) {
      LayoutMdi(MdiLayout.TileHorizontal);
    }

    private void ArrangeIconsToolStripMenuItem_Click(object sender, EventArgs e) {
      LayoutMdi(MdiLayout.ArrangeIcons);
    }

    private void CloseAllToolStripMenuItem_Click(object sender, EventArgs e) {
      foreach (Form childForm in MdiChildren) {
        childForm.Close();
      }
    }

    private void aboutToolStripMenuItem_Click(object sender, EventArgs e) {
      new VersionForm().ShowDialog();
    }

    private void メッセージファイルMToolStripMenuItem_Click(object sender, EventArgs e) {
      OpenFileDialog openFileDialog = new OpenFileDialog();
      openFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
      openFileDialog.Filter = "メッセージ ファイル (*.s9)|*.s9|すべてのファイル (*.*)|*.*";
      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
        string FileName = openFileDialog.FileName;
        byte[] source;
        using (FileStream fs = new FileStream(FileName, FileMode.Open, FileAccess.Read)) {
          source = new byte[fs.Length];
          fs.Read(source, 0, source.Length);
        }
        Form form = new MessageSelectorForm(source, FileName);
        form.MdiParent = this;
        form.Show();
      }
    }
  }
}
