﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace San9.Resource.IO {
  public class Chunk {
    private readonly string identifier;
    private readonly byte[] data;

    public Chunk(string identifier, IEnumerable<byte> data) {
      this.identifier = identifier;
      this.data = data.ToArray();
    }

    public IEnumerable<byte> Source {
      get {
        ByteWriter writer = new ByteWriter(Length);
        writer.Append(Encoding.ASCII.GetBytes(identifier));
        writer.IntOnLittleEndian(data.Length);
        writer.Append(data);
        return writer.Result;
      }
    }

    public int Length {
      get {
        return 8 + data.Length;
      }
    }
  }
}
