﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using San9.Resource.IO;

namespace San9.Resource.Message {
  public abstract class Message {
    public abstract IEnumerable<byte> Source {
      get;
    }

    protected static bool check(ByteReader source, byte[] expected) {
      for (int i = 0; i < expected.Length; i++)
        if (expected[i] != source[source.Index + i])
          return false;
      source.Skip(expected.Length);
      return true;
    }

    public static Message Parse(IEnumerable<byte> source) {
      ByteReader reader = new ByteReader(source.ToArray());
      Message message = BranchMessage.Parse(reader);
      if (message != null) return message;
      message = RandomMessage.Parse(reader);
      if (message != null) return message;
      message = TextMessage.Parse(reader);
      return message;
    }
  }
}
