﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using San9.Resource.Utility;
using San9.Resource.IO;

namespace San9.Resource.Message {
  public class Noun : Operand {
    public static readonly byte Prefix = 0x02;

    private static readonly BiDictionary<Bytes, string> dictionary = new BiDictionary<Bytes, string>() {
      { new Bytes(0x01, 0x38), "武将1.抜擢関係？" },
      { new Bytes(0x01, 0x39), "武将1.番号" },
      { new Bytes(0x01, 0x47), "武将1.身分？" },
      { new Bytes(0x01, 0x4D), "武将1.統率" },
      { new Bytes(0x01, 0x4E), "武将1.武力" },
      { new Bytes(0x01, 0x4F), "武将1.知力" },
      { new Bytes(0x01, 0x50), "武将1.政治" },
      { new Bytes(0x01, 0x51), "武将1.忠誠01" },
      { new Bytes(0x01, 0x52), "武将1.忠誠02" },
      { new Bytes(0x01, 0x53), "武将1.忠誠03" },
      { new Bytes(0x01, 0x54), "武将1.忠誠04" },
      { new Bytes(0x01, 0x55), "武将1.忠誠05" },
      { new Bytes(0x01, 0x56), "武将1.忠誠06" },
      { new Bytes(0x01, 0x57), "武将1.忠誠07" },
      { new Bytes(0x01, 0x58), "武将1.忠誠08" },
      { new Bytes(0x01, 0x59), "武将1.忠誠09" },
      { new Bytes(0x01, 0x5A), "武将1.忠誠10" },
      { new Bytes(0x01, 0x5B), "武将1.忠誠11" },
      { new Bytes(0x01, 0x5C), "武将1.忠誠12" },
      { new Bytes(0x01, 0x5D), "武将1.忠誠13" },
      { new Bytes(0x01, 0x5E), "武将1.忠誠14" },
      { new Bytes(0x01, 0x5F), "武将1.忠誠15" },
      { new Bytes(0x01, 0x60), "武将1.忠誠16" },
      { new Bytes(0x01, 0x61), "武将1.忠誠17" },
      { new Bytes(0x01, 0x62), "武将1.忠誠18" },
      { new Bytes(0x01, 0x63), "武将1.忠誠19" },
      { new Bytes(0x01, 0x64), "武将1.忠誠20" },
      { new Bytes(0x01, 0x65), "武将1.忠誠21" },
      { new Bytes(0x01, 0x66), "武将1.忠誠22" },
      { new Bytes(0x01, 0x67), "武将1.忠誠23" },
      { new Bytes(0x01, 0x68), "武将1.忠誠24" },
      { new Bytes(0x01, 0x69), "武将1.忠誠25" },
      { new Bytes(0x01, 0x6A), "武将1.忠誠26" },
      { new Bytes(0x01, 0x6B), "武将1.忠誠27" },
      { new Bytes(0x01, 0x6C), "武将1.忠誠28" },
      { new Bytes(0x01, 0x6D), "武将1.忠誠29" },
      { new Bytes(0x01, 0x6E), "武将1.忠誠30" },
      { new Bytes(0x01, 0x6F), "武将1.忠誠31" },
      { new Bytes(0x01, 0x70), "武将1.忠誠32" },
      { new Bytes(0x01, 0x71), "武将1.忠誠33" },
      { new Bytes(0x01, 0x72), "武将1.忠誠34" },
      { new Bytes(0x01, 0x73), "武将1.忠誠35" },
      { new Bytes(0x01, 0x74), "武将1.忠誠36" },
      { new Bytes(0x01, 0x75), "武将1.忠誠37" },
      { new Bytes(0x01, 0x76), "武将1.忠誠38" },
      { new Bytes(0x01, 0x77), "武将1.忠誠39" },
      { new Bytes(0x01, 0x78), "武将1.忠誠40" },
      { new Bytes(0x01, 0x79), "武将1.忠誠41" },
      { new Bytes(0x01, 0x7A), "武将1.忠誠42" },
      { new Bytes(0x01, 0x7B), "武将1.忠誠43" },
      { new Bytes(0x01, 0x7C), "武将1.忠誠44" },
      { new Bytes(0x01, 0x7D), "武将1.忠誠45" },
      { new Bytes(0x01, 0x7E), "武将1.忠誠46" },
      { new Bytes(0x01, 0x7F), "武将1.忠誠47" },
      { new Bytes(0x01, 0x80), "武将1.忠誠48" },
      { new Bytes(0x01, 0x81), "武将1.忠誠49" },
      { new Bytes(0x01, 0x82), "武将1.忠誠50" },
      { new Bytes(0x01, 0x83), "武将1.忠誠" },
      { new Bytes(0x01, 0x85), "武将1.爵位" },
      { new Bytes(0x01, 0x86), "武将1.兵数" },
      { new Bytes(0x01, 0x87), "武将1.俸禄" },
      { new Bytes(0x01, 0x89), "武将1.負傷？" },
      { new Bytes(0x01, 0x8F), "武将1.義理？" },
      { new Bytes(0x01, 0x90), "武将1.野心" },
      { new Bytes(0x01, 0x91), "武将1.性格" },
      { new Bytes(0x01, 0xDA), "武将1.姓名" },
      { new Bytes(0x01, 0xDB), "武将1.姓" },
      { new Bytes(0x01, 0xDC), "武将1.名" },
      { new Bytes(0x01, 0xDD), "武将1.字" },
      { new Bytes(0x01, 0xDE), "武将1.～軍" },
      { new Bytes(0x01, 0xE0), "武将1.所在地？" },
      { new Bytes(0x01, 0xE3), "武将1.爵位姓名" },
      { new Bytes(0x01, 0xF7), "武将1.性別" },

      { new Bytes(0x02, 0x38), "武将2.抜擢関係？" },
      { new Bytes(0x02, 0x39), "武将2.番号" },
      { new Bytes(0x02, 0x47), "武将2.身分？" },
      { new Bytes(0x02, 0x4D), "武将2.統率" },
      { new Bytes(0x02, 0x4E), "武将2.武力" },
      { new Bytes(0x02, 0x4F), "武将2.知力" },
      { new Bytes(0x02, 0x50), "武将2.政治" },
      { new Bytes(0x02, 0x51), "武将2.忠誠01" },
      { new Bytes(0x02, 0x52), "武将2.忠誠02" },
      { new Bytes(0x02, 0x53), "武将2.忠誠03" },
      { new Bytes(0x02, 0x54), "武将2.忠誠04" },
      { new Bytes(0x02, 0x55), "武将2.忠誠05" },
      { new Bytes(0x02, 0x56), "武将2.忠誠06" },
      { new Bytes(0x02, 0x57), "武将2.忠誠07" },
      { new Bytes(0x02, 0x58), "武将2.忠誠08" },
      { new Bytes(0x02, 0x59), "武将2.忠誠09" },
      { new Bytes(0x02, 0x5A), "武将2.忠誠10" },
      { new Bytes(0x02, 0x5B), "武将2.忠誠11" },
      { new Bytes(0x02, 0x5C), "武将2.忠誠12" },
      { new Bytes(0x02, 0x5D), "武将2.忠誠13" },
      { new Bytes(0x02, 0x5E), "武将2.忠誠14" },
      { new Bytes(0x02, 0x5F), "武将2.忠誠15" },
      { new Bytes(0x02, 0x60), "武将2.忠誠16" },
      { new Bytes(0x02, 0x61), "武将2.忠誠17" },
      { new Bytes(0x02, 0x62), "武将2.忠誠18" },
      { new Bytes(0x02, 0x63), "武将2.忠誠19" },
      { new Bytes(0x02, 0x64), "武将2.忠誠20" },
      { new Bytes(0x02, 0x65), "武将2.忠誠21" },
      { new Bytes(0x02, 0x66), "武将2.忠誠22" },
      { new Bytes(0x02, 0x67), "武将2.忠誠23" },
      { new Bytes(0x02, 0x68), "武将2.忠誠24" },
      { new Bytes(0x02, 0x69), "武将2.忠誠25" },
      { new Bytes(0x02, 0x6A), "武将2.忠誠26" },
      { new Bytes(0x02, 0x6B), "武将2.忠誠27" },
      { new Bytes(0x02, 0x6C), "武将2.忠誠28" },
      { new Bytes(0x02, 0x6D), "武将2.忠誠29" },
      { new Bytes(0x02, 0x6E), "武将2.忠誠30" },
      { new Bytes(0x02, 0x6F), "武将2.忠誠31" },
      { new Bytes(0x02, 0x70), "武将2.忠誠32" },
      { new Bytes(0x02, 0x71), "武将2.忠誠33" },
      { new Bytes(0x02, 0x72), "武将2.忠誠34" },
      { new Bytes(0x02, 0x73), "武将2.忠誠35" },
      { new Bytes(0x02, 0x74), "武将2.忠誠36" },
      { new Bytes(0x02, 0x75), "武将2.忠誠37" },
      { new Bytes(0x02, 0x76), "武将2.忠誠38" },
      { new Bytes(0x02, 0x77), "武将2.忠誠39" },
      { new Bytes(0x02, 0x78), "武将2.忠誠40" },
      { new Bytes(0x02, 0x79), "武将2.忠誠41" },
      { new Bytes(0x02, 0x7A), "武将2.忠誠42" },
      { new Bytes(0x02, 0x7B), "武将2.忠誠43" },
      { new Bytes(0x02, 0x7C), "武将2.忠誠44" },
      { new Bytes(0x02, 0x7D), "武将2.忠誠45" },
      { new Bytes(0x02, 0x7E), "武将2.忠誠46" },
      { new Bytes(0x02, 0x7F), "武将2.忠誠47" },
      { new Bytes(0x02, 0x80), "武将2.忠誠48" },
      { new Bytes(0x02, 0x81), "武将2.忠誠49" },
      { new Bytes(0x02, 0x82), "武将2.忠誠50" },
      { new Bytes(0x02, 0x83), "武将2.忠誠" },
      { new Bytes(0x02, 0x85), "武将2.爵位" },
      { new Bytes(0x02, 0x86), "武将2.兵数" },
      { new Bytes(0x02, 0x87), "武将2.俸禄" },
      { new Bytes(0x02, 0x89), "武将2.負傷？" },
      { new Bytes(0x02, 0x8F), "武将2.義理？" },
      { new Bytes(0x02, 0x90), "武将2.野心" },
      { new Bytes(0x02, 0x91), "武将2.性格" },
      { new Bytes(0x02, 0xDA), "武将2.姓名" },
      { new Bytes(0x02, 0xDB), "武将2.姓" },
      { new Bytes(0x02, 0xDC), "武将2.名" },
      { new Bytes(0x02, 0xDD), "武将2.字" },
      { new Bytes(0x02, 0xDE), "武将2.～軍" },
      { new Bytes(0x02, 0xE0), "武将2.所在地？" },
      { new Bytes(0x02, 0xE3), "武将2.爵位姓名" },
      { new Bytes(0x02, 0xF7), "武将2.性別" },

      { new Bytes(0x03, 0x38), "武将3.抜擢関係？" },
      { new Bytes(0x03, 0x39), "武将3.番号" },
      { new Bytes(0x03, 0x47), "武将3.身分？" },
      { new Bytes(0x03, 0x4D), "武将3.統率" },
      { new Bytes(0x03, 0x4E), "武将3.武力" },
      { new Bytes(0x03, 0x4F), "武将3.知力" },
      { new Bytes(0x03, 0x50), "武将3.政治" },
      { new Bytes(0x03, 0x51), "武将3.忠誠01" },
      { new Bytes(0x03, 0x52), "武将3.忠誠02" },
      { new Bytes(0x03, 0x53), "武将3.忠誠03" },
      { new Bytes(0x03, 0x54), "武将3.忠誠04" },
      { new Bytes(0x03, 0x55), "武将3.忠誠05" },
      { new Bytes(0x03, 0x56), "武将3.忠誠06" },
      { new Bytes(0x03, 0x57), "武将3.忠誠07" },
      { new Bytes(0x03, 0x58), "武将3.忠誠08" },
      { new Bytes(0x03, 0x59), "武将3.忠誠09" },
      { new Bytes(0x03, 0x5A), "武将3.忠誠10" },
      { new Bytes(0x03, 0x5B), "武将3.忠誠11" },
      { new Bytes(0x03, 0x5C), "武将3.忠誠12" },
      { new Bytes(0x03, 0x5D), "武将3.忠誠13" },
      { new Bytes(0x03, 0x5E), "武将3.忠誠14" },
      { new Bytes(0x03, 0x5F), "武将3.忠誠15" },
      { new Bytes(0x03, 0x60), "武将3.忠誠16" },
      { new Bytes(0x03, 0x61), "武将3.忠誠17" },
      { new Bytes(0x03, 0x62), "武将3.忠誠18" },
      { new Bytes(0x03, 0x63), "武将3.忠誠19" },
      { new Bytes(0x03, 0x64), "武将3.忠誠20" },
      { new Bytes(0x03, 0x65), "武将3.忠誠21" },
      { new Bytes(0x03, 0x66), "武将3.忠誠22" },
      { new Bytes(0x03, 0x67), "武将3.忠誠23" },
      { new Bytes(0x03, 0x68), "武将3.忠誠24" },
      { new Bytes(0x03, 0x69), "武将3.忠誠25" },
      { new Bytes(0x03, 0x6A), "武将3.忠誠26" },
      { new Bytes(0x03, 0x6B), "武将3.忠誠27" },
      { new Bytes(0x03, 0x6C), "武将3.忠誠28" },
      { new Bytes(0x03, 0x6D), "武将3.忠誠29" },
      { new Bytes(0x03, 0x6E), "武将3.忠誠30" },
      { new Bytes(0x03, 0x6F), "武将3.忠誠31" },
      { new Bytes(0x03, 0x70), "武将3.忠誠32" },
      { new Bytes(0x03, 0x71), "武将3.忠誠33" },
      { new Bytes(0x03, 0x72), "武将3.忠誠34" },
      { new Bytes(0x03, 0x73), "武将3.忠誠35" },
      { new Bytes(0x03, 0x74), "武将3.忠誠36" },
      { new Bytes(0x03, 0x75), "武将3.忠誠37" },
      { new Bytes(0x03, 0x76), "武将3.忠誠38" },
      { new Bytes(0x03, 0x77), "武将3.忠誠39" },
      { new Bytes(0x03, 0x78), "武将3.忠誠40" },
      { new Bytes(0x03, 0x79), "武将3.忠誠41" },
      { new Bytes(0x03, 0x7A), "武将3.忠誠42" },
      { new Bytes(0x03, 0x7B), "武将3.忠誠43" },
      { new Bytes(0x03, 0x7C), "武将3.忠誠44" },
      { new Bytes(0x03, 0x7D), "武将3.忠誠45" },
      { new Bytes(0x03, 0x7E), "武将3.忠誠46" },
      { new Bytes(0x03, 0x7F), "武将3.忠誠47" },
      { new Bytes(0x03, 0x80), "武将3.忠誠48" },
      { new Bytes(0x03, 0x81), "武将3.忠誠49" },
      { new Bytes(0x03, 0x82), "武将3.忠誠50" },
      { new Bytes(0x03, 0x83), "武将3.忠誠" },
      { new Bytes(0x03, 0x85), "武将3.爵位" },
      { new Bytes(0x03, 0x86), "武将3.兵数" },
      { new Bytes(0x03, 0x87), "武将3.俸禄" },
      { new Bytes(0x03, 0x89), "武将3.負傷？" },
      { new Bytes(0x03, 0x8F), "武将3.義理？" },
      { new Bytes(0x03, 0x90), "武将3.野心" },
      { new Bytes(0x03, 0x91), "武将3.性格" },
      { new Bytes(0x03, 0xDA), "武将3.姓名" },
      { new Bytes(0x03, 0xDB), "武将3.姓" },
      { new Bytes(0x03, 0xDC), "武将3.名" },
      { new Bytes(0x03, 0xDD), "武将3.字" },
      { new Bytes(0x03, 0xDE), "武将3.～軍" },
      { new Bytes(0x03, 0xE0), "武将3.所在地？" },
      { new Bytes(0x03, 0xE3), "武将3.爵位姓名" },
      { new Bytes(0x03, 0xF7), "武将3.性別" },

      { new Bytes(0x04, 0x38), "武将4.抜擢関係？" },
      { new Bytes(0x04, 0x39), "武将4.番号" },
      { new Bytes(0x04, 0x47), "武将4.身分？" },
      { new Bytes(0x04, 0x4D), "武将4.統率" },
      { new Bytes(0x04, 0x4E), "武将4.武力" },
      { new Bytes(0x04, 0x4F), "武将4.知力" },
      { new Bytes(0x04, 0x50), "武将4.政治" },
      { new Bytes(0x04, 0x51), "武将4.忠誠01" },
      { new Bytes(0x04, 0x52), "武将4.忠誠02" },
      { new Bytes(0x04, 0x53), "武将4.忠誠03" },
      { new Bytes(0x04, 0x54), "武将4.忠誠04" },
      { new Bytes(0x04, 0x55), "武将4.忠誠05" },
      { new Bytes(0x04, 0x56), "武将4.忠誠06" },
      { new Bytes(0x04, 0x57), "武将4.忠誠07" },
      { new Bytes(0x04, 0x58), "武将4.忠誠08" },
      { new Bytes(0x04, 0x59), "武将4.忠誠09" },
      { new Bytes(0x04, 0x5A), "武将4.忠誠10" },
      { new Bytes(0x04, 0x5B), "武将4.忠誠11" },
      { new Bytes(0x04, 0x5C), "武将4.忠誠12" },
      { new Bytes(0x04, 0x5D), "武将4.忠誠13" },
      { new Bytes(0x04, 0x5E), "武将4.忠誠14" },
      { new Bytes(0x04, 0x5F), "武将4.忠誠15" },
      { new Bytes(0x04, 0x60), "武将4.忠誠16" },
      { new Bytes(0x04, 0x61), "武将4.忠誠17" },
      { new Bytes(0x04, 0x62), "武将4.忠誠18" },
      { new Bytes(0x04, 0x63), "武将4.忠誠19" },
      { new Bytes(0x04, 0x64), "武将4.忠誠20" },
      { new Bytes(0x04, 0x65), "武将4.忠誠21" },
      { new Bytes(0x04, 0x66), "武将4.忠誠22" },
      { new Bytes(0x04, 0x67), "武将4.忠誠23" },
      { new Bytes(0x04, 0x68), "武将4.忠誠24" },
      { new Bytes(0x04, 0x69), "武将4.忠誠25" },
      { new Bytes(0x04, 0x6A), "武将4.忠誠26" },
      { new Bytes(0x04, 0x6B), "武将4.忠誠27" },
      { new Bytes(0x04, 0x6C), "武将4.忠誠28" },
      { new Bytes(0x04, 0x6D), "武将4.忠誠29" },
      { new Bytes(0x04, 0x6E), "武将4.忠誠30" },
      { new Bytes(0x04, 0x6F), "武将4.忠誠31" },
      { new Bytes(0x04, 0x70), "武将4.忠誠32" },
      { new Bytes(0x04, 0x71), "武将4.忠誠33" },
      { new Bytes(0x04, 0x72), "武将4.忠誠34" },
      { new Bytes(0x04, 0x73), "武将4.忠誠35" },
      { new Bytes(0x04, 0x74), "武将4.忠誠36" },
      { new Bytes(0x04, 0x75), "武将4.忠誠37" },
      { new Bytes(0x04, 0x76), "武将4.忠誠38" },
      { new Bytes(0x04, 0x77), "武将4.忠誠39" },
      { new Bytes(0x04, 0x78), "武将4.忠誠40" },
      { new Bytes(0x04, 0x79), "武将4.忠誠41" },
      { new Bytes(0x04, 0x7A), "武将4.忠誠42" },
      { new Bytes(0x04, 0x7B), "武将4.忠誠43" },
      { new Bytes(0x04, 0x7C), "武将4.忠誠44" },
      { new Bytes(0x04, 0x7D), "武将4.忠誠45" },
      { new Bytes(0x04, 0x7E), "武将4.忠誠46" },
      { new Bytes(0x04, 0x7F), "武将4.忠誠47" },
      { new Bytes(0x04, 0x80), "武将4.忠誠48" },
      { new Bytes(0x04, 0x81), "武将4.忠誠49" },
      { new Bytes(0x04, 0x82), "武将4.忠誠50" },
      { new Bytes(0x04, 0x83), "武将4.忠誠" },
      { new Bytes(0x04, 0x85), "武将4.爵位" },
      { new Bytes(0x04, 0x86), "武将4.兵数" },
      { new Bytes(0x04, 0x87), "武将4.俸禄" },
      { new Bytes(0x04, 0x89), "武将4.負傷？" },
      { new Bytes(0x04, 0x8F), "武将4.義理？" },
      { new Bytes(0x04, 0x90), "武将4.野心" },
      { new Bytes(0x04, 0x91), "武将4.性格" },
      { new Bytes(0x04, 0xDA), "武将4.姓名" },
      { new Bytes(0x04, 0xDB), "武将4.姓" },
      { new Bytes(0x04, 0xDC), "武将4.名" },
      { new Bytes(0x04, 0xDD), "武将4.字" },
      { new Bytes(0x04, 0xDE), "武将4.～軍" },
      { new Bytes(0x04, 0xE0), "武将4.所在地？" },
      { new Bytes(0x04, 0xE3), "武将4.爵位姓名" },
      { new Bytes(0x04, 0xF7), "武将4.性別" },

      { new Bytes(0x15, 0x36), "アイテム.番号" },
      { new Bytes(0x15, 0x43), "アイテム.名称" },

      { new Bytes(0x1F, 0x32), "勢力1.番号" },
      { new Bytes(0x1F, 0x3F), "勢力1.国号" },
      { new Bytes(0x1F, 0x7C), "勢力1.連合盟主？" },
      { new Bytes(0x1F, 0xBA), "勢力1.金" },
      { new Bytes(0x1F, 0xC7), "勢力1.名称" },
      { new Bytes(0x1F, 0xC8), "勢力1.官爵" },
      { new Bytes(0x1F, 0xC9), "勢力1.君主" },
      { new Bytes(0x1F, 0xCB), "勢力1.軍団長？" },
      { new Bytes(0x1F, 0xCE), "勢力1.軍団" },

      { new Bytes(0x20, 0x32), "勢力2.番号" },
      { new Bytes(0x20, 0x3F), "勢力2.国号" },
      { new Bytes(0x20, 0x7C), "勢力2.連合盟主？" },
      { new Bytes(0x20, 0xBA), "勢力2.金" },
      { new Bytes(0x20, 0xC7), "勢力2.名称" },
      { new Bytes(0x20, 0xC8), "勢力2.官爵" },
      { new Bytes(0x20, 0xC9), "勢力2.君主" },
      { new Bytes(0x20, 0xCB), "勢力2.軍団長？" },
      { new Bytes(0x20, 0xCE), "勢力2.軍団" },

      { new Bytes(0x33, 0x45), "部隊1.命令？" },
      { new Bytes(0x33, 0x79), "部隊1.名称？" },

      { new Bytes(0x34, 0x45), "部隊2.命令？" },
      { new Bytes(0x34, 0x79), "部隊2.名称？" },

      { new Bytes(0x3D, 0x3E), "地域1.障害物？" },
      { new Bytes(0x3D, 0x40), "地域1.なぞ？" },
      { new Bytes(0x3D, 0x9E), "地域1.城砦？" },
      { new Bytes(0x3D, 0x9F), "地域1.施設？" },
      { new Bytes(0x3D, 0xA0), "地域1.部隊？" },
      { new Bytes(0x3D, 0xA7), "地域1.都市？" },
      { new Bytes(0x3D, 0xA8), "地域1.工作物？" },

      { new Bytes(0x3E, 0x3E), "地域2.障害物？" },
      { new Bytes(0x3E, 0x40), "地域2.なぞ？" },
      { new Bytes(0x3E, 0x9E), "地域2.城砦？" },
      { new Bytes(0x3E, 0x9F), "地域2.施設？" },
      { new Bytes(0x3E, 0xA0), "地域2.部隊？" },
      { new Bytes(0x3E, 0xA7), "地域2.都市？" },
      { new Bytes(0x3E, 0xA8), "地域2.工作物？" },

      { new Bytes(0x47, 0x36), "兵種？" },
      { new Bytes(0x47, 0x61), "兵法？" },
      { new Bytes(0x48, 0x36), "兵種？？" },
      { new Bytes(0x48, 0x61), "兵法？？" },

      { new Bytes(0x65), "汎用.数値1？" },
      { new Bytes(0x66), "汎用.数値2？" },
      { new Bytes(0x67), "汎用.数値3？" },
      { new Bytes(0x68), "汎用.数値4？" },

      { new Bytes(0x79), "汎用.文字列1？" },
      { new Bytes(0x7A), "汎用.文字列2？" },
      { new Bytes(0x7B), "汎用.文字列3？" },
      { new Bytes(0x7C), "汎用.文字列4？" },
      { new Bytes(0x7D), "汎用.文字列5？" },

      { new Bytes(0xC9, 0x25, 0x35, 0x30), "三兄弟生存フラグ？" },
      { new Bytes(0xCC, 0x02, 0x01, 0x02, 0x02), "親フラグ1-2？" },
      { new Bytes(0xCC, 0x02, 0x01, 0x02, 0x03), "親フラグ1-3？" },
      { new Bytes(0xCC, 0x02, 0x02, 0x02, 0x03), "親フラグ2-3？" },
      { new Bytes(0xCD, 0x02, 0x01, 0x02, 0x02), "子フラグ1-2？" },
      { new Bytes(0xCD, 0x02, 0x01, 0x02, 0x03), "子フラグ1-3？" },
      { new Bytes(0xCD, 0x02, 0x02, 0x02, 0x03), "子フラグ2-3？" },
      { new Bytes(0xCE, 0x02, 0x01, 0x02, 0x02), "友好フラグ1-2？" },
      { new Bytes(0xCE, 0x02, 0x01, 0x02, 0x03), "友好フラグ1-3？" },
      { new Bytes(0xCE, 0x02, 0x02, 0x02, 0x03), "友好フラグ2-3" },
      { new Bytes(0xCF, 0x02, 0x01, 0x02, 0x02), "汎用フラグ1-2？" },
      { new Bytes(0xCF, 0x02, 0x01, 0x02, 0x03), "汎用フラグ1-3？" },
      { new Bytes(0xCF, 0x02, 0x02, 0x02, 0x03), "汎用フラグ2-3？" },
      { new Bytes(0xD0, 0x02, 0x01, 0x02, 0x02), "ラヴ1-2？" },
      { new Bytes(0xD0, 0x02, 0x01, 0x02, 0x03), "ラヴ1-3？" },
      { new Bytes(0xD0, 0x02, 0x02, 0x02, 0x03), "ラヴ2-3？" },
      { new Bytes(0xD1, 0x02, 0x01, 0x02, 0x02), "好感度1-2？" },
      { new Bytes(0xD1, 0x02, 0x01, 0x02, 0x03), "好感度1-3？" },
      { new Bytes(0xD1, 0x02, 0x02, 0x02, 0x03), "好感度2-3？" },

      { new Bytes(0xD4), "シナリオ番号" },
      { new Bytes(0xD5), "年" },
      { new Bytes(0xD7), "月" },

      { new Bytes(0xDA, 0x02, 0x1F, 0x02, 0x20), "友好度？" },

      { new Bytes(0xDC), "謎フラグ1" },

      { new Bytes(0xDD, 0x31, 0x032), "謎フラグ2" },
      { new Bytes(0xDD, 0x032), "謎フラグ3" },

      { new Bytes(0xDF, 0x02, 0x02), "攻城フラグ？" }
    };

    private readonly Bytes identifier;

    public Noun(Bytes identifier) {
      if (!dictionary.ContainsKey(identifier)) throw new ArgumentException();
      this.identifier = identifier;
    }

    public Noun(string identifier) {
      if (!dictionary.ContainsKey(identifier)) throw new ArgumentException();
      this.identifier = dictionary[identifier];
    }

    public static Noun Parse(ByteReader source) {
      if (source.Current != Prefix) return null;
      source.Skip(1);
      for (int i = 1; i <= 5; i++) {
        Bytes identifier = new Bytes(source.Take(i).ToArray());
        if (dictionary.ContainsKey(identifier)) {
          source.Skip(i);
          return new Noun(identifier);
        }
      }
      throw new ArgumentException(); 
    }

    public override IEnumerable<byte> Source {
      get {
        yield return Prefix;
        foreach (byte b in identifier.Source)
          yield return b;
      }
    }

    public override string Text {
      get { return dictionary[identifier]; }
    }
  }
}
