﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace San9.Resource.Utility {
  public class BiDictionary<T1, T2> : IEnumerable<KeyValuePair<T1, T2>> {
    private readonly Dictionary<T1, T2> dictionary1 = new Dictionary<T1, T2>();
    private readonly Dictionary<T2, T1> dictionary2 = new Dictionary<T2, T1>();

    public T2 this[T1 key] {
      get { return dictionary1[key]; }
    }

    public T1 this[T2 key] {
      get { return dictionary2[key]; }
    }

    public bool ContainsKey(T1 key) {
      return dictionary1.ContainsKey(key);
    }

    public bool ContainsKey(T2 key) {
      return dictionary2.ContainsKey(key);
    }

    public void Add(T1 key, T2 value) {
      dictionary1.Add(key, value);
      dictionary2.Add(value, key);
    }

    public void Add(T2 key, T1 value) {
      Add(value, key);
    }

    public IEnumerator<KeyValuePair<T1, T2>> GetEnumerator() {
      return dictionary1.GetEnumerator();
    }

    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
      return dictionary1.GetEnumerator();
    }
  }
}
