﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;

namespace San9.Resource.IO {
  [TestFixture]
  public class ByteWriterTest {
    [Test]
    public void Test() {
      ByteWriter writer = new ByteWriter(16);
      writer.Append(0x01);
      Assert.AreEqual(new byte[] { 0x01 }, writer.Result);
      writer.Append(new byte[] { 0x02, 0x03 });
      Assert.AreEqual(new byte[] { 0x01, 0x02, 0x03 }, writer.Result);
      writer.ShortOnBigEndian(0x0405);
      Assert.AreEqual(new byte[] { 0x01, 0x02, 0x03, 0x04, 0x05 }, writer.Result);
      writer.ShortOnLittleEndian(0x0607);
      Assert.AreEqual(new byte[] { 0x01, 0x02, 0x03, 0x04, 0x05, 0x07, 0x06 }, writer.Result);
      writer.IntOnBigEndian(0x08090A0B);
      Assert.AreEqual(new byte[] { 0x01, 0x02, 0x03, 0x04, 0x05, 0x07, 0x06, 0x08, 0x09, 0x0A, 0x0B }, writer.Result);
      writer.IntOnLittleEndian(0x0C0D0E0F);
      Assert.AreEqual(new byte[] { 0x01, 0x02, 0x03, 0x04, 0x05, 0x07, 0x06, 0x08, 0x09, 0x0A, 0x0B, 0x0F, 0x0E, 0x0D, 0x0C }, writer.Result);
    }
  }
}
