﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using San9.Resource.IO;

namespace San9.Resource.Message {
  [TestFixture]
  public class ConditionTest {
    [TestCase(new byte[] { 0x02, 0x01, 0x39 })]
    [TestCase(new byte[] { 0x02, 0x01, 0x39, 0x04, 0x3D, 0x02, 0x02, 0x39 })]
    [TestCase(new byte[] { 0x02, 0x01, 0x39, 0x04, 0x3D, 0x25, 0x02, 0x02, 0x39 })]
    [TestCase(new byte[] { 0x02, 0x01, 0x39, 0x04, 0x3D, 0x31, 0x32 })]
    [TestCase(new byte[] { 0x02, 0x01, 0x39, 0x04, 0x3D, 0x25, 0x31, 0x32 })]
    public void Test1(byte[] bytes) {
      ByteReader source = new ByteReader(bytes);
      Condition condition = Condition.Parse(source);
      Assert.AreEqual(bytes, condition.Source);
    }
  }
}
