﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using San9.Resource.IO;

namespace San9.Resource.Message {
  [TestFixture]
  public class JumpMessageTest {
    [Test]
    public void Test1() {
      JumpMessage message = new JumpMessage(0x0102);
      Assert.AreEqual(new byte[] { 0x01, 0x4A, 0x02, 0x01, 0x05, 0x05, 0x05 }, message.Source);
      Assert.AreEqual(0x0102, message.Address);
    }

    [Test]
    public void Test2() {
      ByteReader source = new ByteReader(new byte[] { 0x01, 0x02, 0x01, 0x4A, 0x01, 0x02, 0x05, 0x05, 0x05 });
      JumpMessage message = JumpMessage.Parse(source);
      Assert.AreEqual(true, message == null);
      source.Skip(2);
      message = JumpMessage.Parse(source);
      Assert.AreEqual(new byte[] { 0x01, 0x4A, 0x01, 0x02, 0x05, 0x05, 0x05 }, message.Source);
      Assert.AreEqual(0x0201, message.Address);
    }
  }
}
